## R-1.3.0.tgz

=== src/gnuwin32/Makefile ===
include MkRules

all: rbuild rpackage rdocs

## configuration macros
HELP = YES
WINHELP = CHM# NO, CHM, BOTH

LEA_MALLOC=YES

PACKAGES = base ctest eda lqs modreg mva nls splines stepfun ts
ALLPACKAGES = $(PACKAGES) tcltk
RPREFIX = rw1030

RHOME = $(shell perl pwd.pl ../..)# must be absolute path
RLIB = $(RHOME)/library
PKGDIR = $(RHOME)/src/library
PKGD = $(shell perl pwd.pl $(PKGDIR))# must be absolute path

OPTFLAGS=-O2 -Wall -pedantic
## use FOPTFLAGS where complex*16 is used.
FOPTFLAGS=-O2 -Wall
ifdef DEBUG
 OPTFLAGS+=-g
 FOPTFLAGS+=-g
 DLLFLAGS=
else
 DLLFLAGS=-s
endif

R-DLLFLAGS = -mwindows
R-DLLLIBS = -L. $(FLIBS) -lcomctl32 -lversion
SOURCES = $(filter-out malloc.c,$(wildcard *.c *.f))
OBJS = $(SOURCES:.c=.o)
MAINLIBS = libmain.a libappl.a libmath.a
EXTRALIBS = ga.a gl.a xdr.a em.a bitmap/zlib/libz.a

LIBFILES = $(foreach i, $(ALLPACKAGES), ../../library/$i) ../../library/R.css
PKGS = $(foreach i,$(PACKAGES),pkg-$i)
PKGCLEAN = $(foreach i,$(ALLPACKAGES),pkgclean-$i)

# flags to ensure that Doug Lea's malloc is used:
ifdef LEA_MALLOC
extra-CFLAGS+=-DLEA_MALLOC
OBJS-EXTRA=malloc.o
endif

.PHONY:  clean veryclean  rlibs fixfiles front-ends


# separate as Tcl/Tk headers are needed.
tcl: 
	$(MAKE) STAMP=NO pkg-tcltk

CFLAGS = $(OPTFLAGS) -I../include -I. -DHAVE_CONFIG_H
FFLAGS = $(OPTFLAGS)

rbuild: fixfiles rlibs makeMakedeps ../../bin/R.dll libR.a CHTML \
	 ../include/globalvar.h front-ends COPYRIGHTS rmodules

rpackage: fixed/fixdesc ../../library/R.css
	$(MAKE) STAMP=NO $(PKGS)

rinstaller:
	$(MAKE) -C installer PREFIX=$(RPREFIX)

rlibs:
	$(MAKE) -C ../appl  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ../main  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ../nmath OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ./graphapp
	$(MAKE) -C ./getline
	$(MAKE) -C ../extra/xdr
	$(MAKE) -C ./math

rmodules: libRm.a
	$(MAKE) -C ../modules OPTFLAGS='$(OPTFLAGS)' FOPTFLAGS='$(FOPTFLAGS)' -f Makefile.win

COPYRIGHTS: $(RHOME)/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles:
	$(MKDIR) -p ../../bin
	$(MAKE) -C ./fixed
	$(CP) -pr unzip ../..
	$(RM) ../../unzip/*.h

fixed/fixdesc:
	sh fixed/GETDESC $(ALLPACKAGES)

dllversion.o: ../include/Rversion.h

R.dll: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) dllversion.o

Rdll: makeMakedeps ../../bin/R.dll

../../bin/R.dll: fixfiles rlibs R.dll
	$(MKDIR) -p ../../bin
	$(CP) R.dll ../../bin/

front-ends: libR.a
	$(MAKE) -C front-ends

R.a: $(OBJS)
	@$(ECHO) -------- Building $@ --------
	$(AR) cr R.a $^
	$(RANLIB) R.a


# R.dll exports all global symbols BUT import library (libR.a)
# only (all functions) + (global vars listed in exported-vars))

libR.a:  R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def R.exp --output-lib libR.a

R.exp: R.exp1
	(diff R.exp R.exp1 > /dev/null) || $(CP) R.exp1 R.exp

R.exp1: R.a $(MAINLIBS) $(EXTRALIBS) exported-vars
	$(ECHO) EXPORTS > $@
	$(NM) R.a $(MAINLIBS) $(EXTRALIBS) > RDefs
	$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs

# A version needed for the modules that uses R.dll's malloc/.../free:

libRm.a:  Rm.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def Rm.exp --output-lib libRm.a

Rm.exp: Rm.exp1
	(diff Rm.exp Rm.exp1 > /dev/null) || $(CP) Rm.exp1 Rm.exp

Rm.exp1: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) exported-vars
	$(ECHO) EXPORTS > $@
	$(NM) R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) > RDefs
	$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs


# avoid building globalvar.h with errors
../include/globalvar.h: exported-vars
	perl -n makeimps.pl exported-vars > $@

../../library/R.css: ../../doc/html/R.css
	$(CP) $< $@

bitmap/zlib/libz.a:
	$(MAKE) -C bitmap buildzlib

rdocs:
	@$(MAKE) -C ../../doc/manual -f Makefile.win html


#                          ===== Packages ======

CHTML:
ifeq ($(strip $(HELP)),YES)
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) -C ./help -f MkChmDll
endif
ifeq ($(strip $(WINHELP)),BOTH)
	$(MAKE) -C ./help -f MkChmDll
endif
endif

base-HELP = ziponly
nls-HELP = ziponly
ts-HELP = ziponly
base-ZIPDATA = zip
ts-ZIPDATA = zip

bundle-%:
	$(PERL) fixed/dobundle.pl $* $(PKGD) $(RLIB)

pkg-%:  libR.a #../include/globalvar.h
	$(MAKE) DLLNM=$($*-DLLNM)  EXTRADOCS=$($*-EXTRADOCS) \
	  -C $(PKGDIR)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/MakePkg
	@if test -d $(RLIB)/$*/data ; then \
	  $(MAKE) $($*-ZIPDATA)data-$* ; \
	fi
ifeq ($(strip $(HELP)),YES)
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) $($*-HELP)help-$*
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) contents-$*
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) chm-$*
endif
ifeq ($(strip $(WINHELP)),BOTH)
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) winhlp-$* # also makes chm
endif
endif

pkgclean-%:
	$(MAKE) DLLNM=$($*-DLLNM)  EXTRADOCS=$($*-EXTRADOCS) RHOME=$(RHOME) \
	  -C $(PKGDIR)/$* PKG=$* -f $(RHOME)/src/gnuwin32/MakePkg clean

pkgcheck-%:
	@$(ECHO) -------- Testing package $* --------
	-@mkdir -p $(PKGDIR)/$*/check
	@$(MAKE) -C $(PKGDIR)/$*/check PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/check/PkgCheck
	@if test -d $(PKGDIR)/$*/tests ; then \
	  $(MAKE) -C $(PKGDIR)/$*/tests PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	    -f $(RHOME)/src/gnuwin32/check/PkgCheck tests;\
	fi

ziphelp-%:
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziphelp-$*

ziponly-%:
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziponlyhelp-$*

zipdata-%:
	@echo "  zipping data"
	@(cd $(RLIB)/$*/data; \
	  if test -f Rdata.zip ; then \
	    unzip -qou Rdata; \
	  fi; \
	  $(RM) Rdata.zip filelist ; \
	  ls -1 > filelist; \
	  zip -rmq9X Rdata * -x filelist 00Index)

data-%:
	@echo "  not zipping data"


#                          ===== cleaning ======

clean: cleanwin $(PKGCLEAN)
	$(RM) -f ../*/*.o $(WINOBJS) *.a ../*/*.d ../*/Makedeps fixed/fixdesc
	-$(MAKE) -C ../../doc/manual -f Makefile.win distclean
	-$(MAKE) -C ../nmath/standalone -f Makefile.win distclean
	-$(MAKE) -C ../modules -f Makefile.win clean
	-$(MAKE) -C ../../tests -f Makefile.win clean

distclean veryclean: clean
	$(RM) R.exp Rm.exp globalvar.h 
	$(RM) -r ../../bin ../../library ../../modules
	$(RM) ../include/config.h ../include/psignal.h \
	../include/Rconfig.h ../include/version.h 
	$(RM) ../library/*/src/*.o ../library/*/src/*.a
	$(RM) ../library/*/src/*.dll
	$(RM) -r ../library/*/check
	$(RM) ../../doc/html/search/index.txt \
	../../doc/html/packages.html ../../doc/html/rwin.html \
	../../doc/html/rw-FAQ.html ../../doc/html/search/SearchEngine.html
	$(RM) ../../etc/Rconsole ../../etc/Rdevga ../../etc/Rprofile \
	../../etc/rgb.txt ../../share/make/tests.mk \
	../include/FFDecl.h ../include/FFTab.h ../include/Platform.h \
	../include/globalvar.h ../../tests/*.Rout ../../tests/*.Rout.fail
	-$(MAKE) -C installer ISdistclean

cleanwin:
	$(RM) *.o *.exe *.dll *.a *~ \#*\# rw*.zip R.def R.exp1 Rm.exp1\
	   .RData .Rhistory Makedeps *.d
	$(MAKE) -C graphapp clean
	$(MAKE) -C fixed clean
	$(MAKE) -C getline clean
	$(MAKE) -C help clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C ../extra/xdr clean
	$(MAKE) -C math clean
	$(MAKE) -C bitmap clean
	-$(MAKE) -C installer clean ISclean


#                          ===== testing ======

# tests
check test: test-Specific pkgtests

test-Specific:
	-@$(MAKE) -C $(RHOME)/tests -f $(RHOME)/tests/Makefile.win clean
	-@$(MAKE) -C $(RHOME)/tests -f $(RHOME)/tests/Makefile.win RHOME=$(RHOME)


PKGS-CHK = $(foreach i, $(PACKAGES), pkgcheck-$i)
pkgtests: $(PKGS-CHK)


#                          ===== documentation ======

docs manuals:
	@$(MAKE) -C $(RHOME)/doc/manual -f Makefile.win clean
	@$(MAKE) -C $(RHOME)/doc/manual -f Makefile.win R_PKGS='$(ALLPACKAGES)'
	@$(MAKE) ziponly-base


## ===================== Maintainer targets ========================

RVER = $(shell cut -d' ' -f1 ../../VERSION | sed -n 1p)

docfiles: INSTALL FAQs
SEDVER = -e s/@RVER@/$(RVER)/g -e s/@RWVER@/$(RPREFIX)/g

INSTALL: INSTALL.in ../../VERSION
	$(SED) $(SEDVER) INSTALL.in > INSTALL

FAQs: rw-faq fixed/html/rw-FAQ.html

fixed/html/rw-FAQ.html: rw-FAQ.texi ../../VERSION
	@$(SED) $(SEDVER) $< > tmp.texi
	makeinfo --html --no-headers --number-sections -o tmp.html tmp.texi
	-tidy tmp.html > $@ 2> nul
	@$(RM) tmp.texi tmp.html

rw-faq: rw-FAQ.texi ../../VERSION
	$(SED) $(SEDVER) $< | \
	  makeinfo --no-headers --number-sections -o $@

bitmapdll:
	$(MAKE) -C bitmap

distribution: bindist packagedist docsdist

bindist: tcl bitmapdll docfiles
	$(RM) -r $(RPREFIX)
	$(MKDIR) $(RPREFIX)
	$(CP) -pr ../../bin ../../modules ../../afm ../../unzip $(RPREFIX)
	$(MKDIR) $(RPREFIX)/library
	$(CP) -pr $(LIBFILES) $(RPREFIX)/library
# morley.tab is needed for R-intro Appendix A
	$(CP) -p ../library/base/data/morley.tab $(RPREFIX)/library/base/data
	$(RM) $(RPREFIX)/*/Makefile.in
	(cd $(RPREFIX)/bin; $(RM) Rcmd.exe INSTALL REMOVE SHLIB build check \
	   massage-Examples.sh Rd2dvi.sh Rd2txt Rdconv Rdiff.sh Rdindex \
           Sd2Rd Rprof)
	$(MKDIR) $(RPREFIX)/etc
	$(CP) -p ../../etc/Rprofile $(RPREFIX)/etc/Rprofile
	$(CP) -p ../../etc/Rconsole $(RPREFIX)/etc/Rconsole
	$(CP) -p ../../etc/Rdevga $(RPREFIX)/etc/Rdevga
	$(CP) -p ../../etc/rgb.txt $(RPREFIX)/etc/rgb.txt
	$(MKDIR) -p $(RPREFIX)/doc/manual  $(RPREFIX)/share/texmf
	$(CP) -pr ../../doc/html $(RPREFIX)/doc
	$(CP) -p ../../doc/manual/*.html $(RPREFIX)/doc/manual
	$(CP) -pr ../../share/texmf $(RPREFIX)/share
	$(CP) -p ../../AUTHORS ../../COPYING COPYRIGHTS ../../FAQ ../../NEWS \
		../../THANKS ../../Y2K $(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g readme > $(RPREFIX)/README
	$(CP) -p rw-faq $(RPREFIX)/rw-FAQ
	$(CP) -p CHANGES README.Rterm $(RPREFIX)
# convert docs and batch files to CRLF: might already be on Windows, though.
ifeq ($(strip $(BUILD)),CROSS)
	zip -l dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -ao dosfiles.zip
else
	zip dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -o dosfiles.zip
endif
	$(RM) dosfiles.zip
	$(RM) $(RPREFIX)b1.zip $(RPREFIX)b2.zip $(RPREFIX)h.zip \
	   $(RPREFIX)w.zip $(RPREFIX)l.zip $(RPREFIX)ch.zip
	$(RM) anindex.zip
	zip -mrX anindex.zip $(RPREFIX)/library/*/help/AnIndex
	zip -mr9X $(RPREFIX)h.zip $(RPREFIX)/library/*/help
	unzip anindex.zip
	$(RM) anindex.zip
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.html
	zip -rm9X $(RPREFIX)w.zip $(RPREFIX)/doc/html \
          $(RPREFIX)/doc/manual/*.html \
	  $(RPREFIX)/library/*/html $(RPREFIX)/library/R.css
	-zip -rm9X $(RPREFIX)ch.zip $(RPREFIX)/library/*/chtml \
	  $(RPREFIX)/bin/Rchtml.dll
#	$(RM) $(RPREFIX)/library/*/winhlp/*.GID
#	-zip -rm9X $(RPREFIX)wh.zip $(RPREFIX)/library/*/winhlp
	zip -rm9X $(RPREFIX)l.zip $(RPREFIX)/library/*/latex $(RPREFIX)/share/texmf
	$(RM) -r $(RPREFIX)/doc
	mkdir -p  $(RPREFIX)/doc/html
	$(CP) -p ../../doc/html/faq.html ../../doc/html/rw-FAQ.html \
	  $(RPREFIX)/doc/html
	zip -rm9X $(RPREFIX)b2.zip $(RPREFIX)/library $(RPREFIX)/doc/html
	zip -r9X $(RPREFIX)b1.zip $(RPREFIX)
	$(RM) -rf $(RPREFIX)


#taken from ../include/Makefile.in
SRC_HEADERS = R.h S.h Rdefines.h Rgraphics.h Rinternals.h Rmath.h
OBJ_HEADERS = Rconfig.h Rversion.h
GW32_HEADERS = globalvar.h

packagedist:
	$(RM) -r $(RPREFIX)sp.zip $(RPREFIX)
	$(MKDIR) -p $(RPREFIX) $(RPREFIX)/bin $(RPREFIX)/etc \
	  $(RPREFIX)/doc $(RPREFIX)/doc/html $(RPREFIX)/share \
	  $(RPREFIX)/src/include $(RPREFIX)/src/library \
	  $(RPREFIX)/src/gnuwin32/fixed
	$(CP) ../../doc/html/logo.jpg $(RPREFIX)/doc/html
	$(CP) ../../doc/KEYWORDS* $(RPREFIX)/doc
	$(CP) -p exported-vars R.exp MkRules MakePkg MakeDll \
	  pwd.pl makeDllRes.pl install-save.sh $(RPREFIX)/src/gnuwin32
	$(CP) -p Makefile.packages $(RPREFIX)/src/gnuwin32/Makefile
	$(CP) fixed/dobundle.pl $(RPREFIX)/src/gnuwin32/fixed
	$(CP) -pr help check $(RPREFIX)/src/gnuwin32
	$(RM) $(RPREFIX)/src/gnuwin32/help/*.c \
	  $(RPREFIX)/src/gnuwin32/help/MkChmDll

=== src/macintosh/Makefile ===
## This Makefile is to be run on a Unix / Linux machine to make
## files necessary for the Macintosh build.

RHOME = ../..
all: profiles library headers html

## ------------- headers -----------
headers: ../include/config.h Rconfig.h Rversion.h FFDecl.h FFTab.h

../include/config.h: config.mac.h
	cp config.mac.h ../include/config.h

Rconfig.h: ../include/config.h
	(cd ../include; $(RHOME)/tools/GETCONFIG > ../macintosh/Rconfig.h)

Rversion.h: $(RHOME)/date-stamp $(RHOME)/VERSION
	$(RHOME)/tools/GETVERSION > Rversion.h

SED0='/^\#/d'
SED01='/Rsockfork/d'
SED1='s/F77_SUBROUTINE(\(.*\))/void * \1_();/'
SED2='s/C_FUNCTION(\(.*\))/void * \1();/'
SED3='s/F77_SUBROUTINE(\(.*\))/{ "\1_",	\1_ },/'
SED4='s/C_FUNCTION(\(.*\))/{ "\1",	\1 },/'

FFDecl.h: ../appl/ROUTINES
	sed -e $(SED0) -e $(SED01) -e $(SED1) -e $(SED2) $< > $@
FFTab.h: ../appl/ROUTINES
	sed -e $(SED0) -e $(SED01) -e $(SED3) -e $(SED4) $< > $@

## ------------- profiles -----------
profiles: $(RHOME)/library/base/R/Rprofile

$(RHOME)/library/base/R/Rprofile:  ../library/profile/Common.R \
../library/profile/Rprofile.mac
	@echo -------- Building $@ from $^--------
	mkdir -p $(RHOME)/library/base/R
	cat ../library/profile/Common.R ../library/profile/Rprofile.mac > $(RHOME)/library/base/R/Rprofile

## ------------- library -----------
PACKAGES = base ctest eda lqs modreg mva nls splines stepfun ts
DATA = base modreg mva nls ts
DEMO = base eda

fixdesc:
	echo "creating DESCRIPTION files"
	@sh ../gnuwin32/fixed/GETDESC $(PACKAGES)

library: mainfiles datafiles help zipfiles demofiles

mainfiles: fixdesc
	@mkdir -p $(RHOME)/library
	@for pkg in $(PACKAGES); do \
	  mkdir -p $(RHOME)/library/$${pkg}; \
	  cp ../library/$${pkg}/DESCRIPTION $(RHOME)/library/$${pkg}; \
	  cp ../library/$${pkg}/INDEX ../library/$${pkg}/TITLE $(RHOME)/library/$${pkg}; \
	  echo "installing R files in $${pkg}"; \
	  mkdir -p $(RHOME)/library/$${pkg}/R; \
	  cat ../library/$${pkg}/R/*.R \
	    > $(RHOME)/library/$${pkg}/R/$${pkg};\
	  if test -d ../library/$${pkg}/R/mac; then \
	    cat ../library/$${pkg}/R/mac/*.R >> $(RHOME)/library/$${pkg}/R/$${pkg};\
	  fi \
	done

datafiles:
	@for pkg in $(DATA); do \
	  echo "installing data files in $${pkg}"; \
	  mkdir -p $(RHOME)/library/$${pkg}/data; \
	  cp ../library/$${pkg}/data/00Index \
	    ../library/$${pkg}/data/*.* $(RHOME)/library/$${pkg}/data; \
	done

demofiles:
	@for pkg in $(DEMO); do \
	echo "installing demo files in $${pkg}"; \
	mkdir -p $(RHOME)/library/$${pkg}/demo; \
	cp ../library/$${pkg}/demo/00Index \
         ../library/$${pkg}/demo/*.* $(RHOME)/library/$${pkg}/demo; \
	done

help:
	@for pkg in $(PACKAGES); do \
	  PERL5LIB=$(RHOME)/share/perl perl build-help -txt -html -example -latex ../library/$${pkg} $(RHOME)/library; \
	  perl Rd2contents ../library/$${pkg} \
           $(RHOME)/library/$${pkg}/CONTENTS; \
	done
	cat $(RHOME)/library/*/CONTENTS > $(RHOME)/doc/html/search/index.txt
	PERL5LIB=$(RHOME)/share/perl perl build-help  -htmllists

zipfiles:
	(cd $(RHOME)/library/base/help; \
	  zip -jqm Rhelp * -x 00Titles AnIndex)
	(cd $(RHOME)/library/base/R-ex; zip -jqm Rex *.R)
	(cd $(RHOME)/library/base/latex; zip -jqm Rhelp *.tex)

## ------------- html -----------

html:
	cp html/*.html $(RHOME)/doc/html

distribution:
	rm -f dist.zip
	(cd $(RHOME); zip -rq9 src/macintosh/dist library doc/html \
	  src/macintosh/FF*.h src/macintosh/Rconfig.h src/macintosh/Rversion.h \
	  -x doc/html/CVS/* doc/html/search/CVS/*)

=== src/extra/xdr/Makefile ===
include ../../gnuwin32/MkRules

CFLAGS=-O2 -I. -DWIN32 -D_X86_

../../gnuwin32/xdr.a: xdr.o xdr_float.o xdr_stdio.o

clean:
	$(RM) *.o *~

=== src/gnuwin32/fixed/Makefile ===
include ../MkRules

all: profiles fixh fixhtml fixbin fixetc fixshare

profiles: ../../../library/base/R/Rprofile

../../../library/base/R/Rprofile:  ../../library/profile/Common.R \
../../library/profile/Rprofile.gnw
	@$(ECHO) -------- Building $@ from $^--------
	mkdir -p ../../../library/base/R
	$(CAT)  $^ > $@


SED0='/^\#/d'
SED01='/Rsockfork/d'
SED1='s/F77_SUBROUTINE(\(.*\))/void * \1_();/'
SED2='s/C_FUNCTION(\(.*\))/void * \1();/'
SED3='s/F77_SUBROUTINE(\(.*\))/	{ "\1_",	\1_},/'
SED4='s/C_FUNCTION(\(.*\))/{ "\1",	\1 },/'

../FFDecl.h: ../../appl/ROUTINES
	$(SED) -e $(SED0) -e $(SED01) -e $(SED1) -e $(SED2) $< > $@
../FFTab.h: ../../appl/ROUTINES
	$(SED) -e $(SED0) -e $(SED01) -e $(SED3) -e $(SED4) $< > $@


fixh: h/config.h ../FFDecl.h ../FFTab.h \
  ../../include/Rconfig.h ../../include/Rversion.h
	$(CP) -p ./h/config.h ./h/psignal.h ../../include
	$(ECHO) done > fixh

../../include/Rconfig.h: h/config.h
	$(SED) -e 1d ../../../tools/GETCONFIG > GC
	(cd h; sh ../GC > ../../../include/Rconfig.h)
	$(RM) GC

../../include/Rversion.h: ../../../date-stamp ../../../VERSION
	$(SED) -e 1d ../../../tools/GETVERSION > ../../../tools/GV
	sh ../../../tools/GV > $@
	$(RM) ../../../tools/GV

../../../bin/massage-Examples.sh: ../../../share/sh/massage-Examples.sh
	$(SED) -e 1d  -e 's/"contr.poly")/"contr.poly"), pager="console"/' $< > $@

../../../bin/check: ../../scripts/check.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/build: ../../scripts/build.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Sd2Rd: ../../scripts/Sd2Rd.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdconv: ../../scripts/Rdconv.in
	$(SED) -e 1d -e s/\"unix\"/\"windows\"/ -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdindex: ../../scripts/Rdindex.in
	$(SED) -e 1d -e s/\"unix\"/\"windows\"/ -e "s/R CMD/Rcmd/" $< > $@

../../../bin/Rdiff.sh: ../../scripts/Rdiff
	$(SED) -e 1d $< > $@

../../../bin/Rprof: ../../scripts/Rprof.in
	$(SED) -e 1d -e "s/R CMD/Rcmd/" $< > $@

fixbin: ../../../bin/massage-Examples.sh ../../../bin/build \
	   ../../../bin/check ../../../bin/Rdconv ../../../bin/Rdindex \
	   ../../../bin/Sd2Rd ../../../bin/Rdiff.sh ../../../bin/Rprof cp2bin
	$(ECHO) done > fixbin

cp2bin: $(filter-out ./bin/CVS, $(wildcard ./bin/*))
	zip -q bins $^
	unzip -oaq bins -d  ../../..
	$(RM) bins.zip

fixhtml: $(wildcard ./html/*.html) ../../../doc/html/search/SearchEngine.html
	$(CP) -p ./html/*.html ../../../doc/html
	$(ECHO) done > fixhtml

fixetc: $(filter-out ./etc/CVS, $(wildcard ./etc/*))
	$(CP) -p $^ ../../../etc
	$(ECHO) done > fixetc

fixshare: ./share/tests.mk
	$(MKDIR) -p ../../../share/make
	$(CP) -p $^ ../../../share/make
	$(ECHO) done > fixshare	

clean:
	$(RM) *~ */*~ fixhtml fixh fixbin fixetc fixshare

../../../doc/html/search/SearchEngine.html:../../../doc/KEYWORDS.db
	(cd ../../../doc; \
	cat html/search/SearchEngine-head.html > html/search/SearchEngine.html; \
	perl ../tools/keywords2html.pl KEYWORDS.db >> html/search/SearchEngine.html; \
	cat html/search/SearchEngine-foot.html >> html/search/SearchEngine.html)

=== src/gnuwin32/front-ends/Makefile ===
include ../MkRules

ifdef DEBUG
  OPTFLAGS=-g
  LINKFLAGS=
  DLLFLAGS=
else
  OPTFLAGS=-O2 -Wall -pedantic
  LINKFLAGS=-s
  DLLFLAGS=-s
endif
CFLAGS=$(OPTFLAGS) -I../../include

all: ../../../bin/Rgui.exe ../../../bin/Rterm.exe \
     ../../../bin/Rcmd.exe  ../../../bin/RSetReg.exe  \
    ../../../bin/Rproxy.dll

../../../bin/Rgui.exe: Rgui.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

../../../bin/Rterm.exe: Rterm.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@	

../../../bin/Rcmd.exe: Rcmd.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

../../../bin/RSetReg.exe: RSetReg.exe
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

graphappmain.o: ../graphapp/graphappmain.c
	$(CC) -c -o $@ -I../graphapp $(CFLAGS) $^

Rgui-LINKFLAGS=-mwindows
Rterm-LIBS=-luser32 -L.. -lR
Rgui-LIBS=-L.. -lR
rgui-CFLAGS=-DWin32
rterm-CFLAGS=-DWin32

Rgui.exe: graphappmain.o  rgui.o rgico.o

Rterm.exe: graphappmain.o rterm.o rtico.o

Rcmd.exe: rcmd.o ../rhome.o rcico.o

RSetReg.exe: RSetReg.o ../rhome.o rcico.o

rgui.o rterm.o rproxy_impl.o rgico.o rtico.o rcico.o: ../../include/Rversion.h

clean:
	$(RM) *.o *.obj *.exe *~ *.exp *.def *.dll *.lib

bdx-CFLAGS=-I../../include
rproxy-DLLFLAGS=-mwindows
rproxy-DLLLIBS=-L.. -lR
rproxy.dll: rproxy.o rproxy_dev.o rproxy_impl.o bdx.o rtico.o

../../../bin/Rproxy.dll: rproxy.dll
	$(MKDIR) -p ../../../bin
	$(CP) $^ $@

=== src/gnuwin32/help/Makefile ===
# default target builds indices
DOS=# -dosnames   # for file-name mapping
PERL=perl
CAT=cat
CP=cp
RM=rm
MKDIR=mkdir

RHOME=$(shell perl ../pwd.pl ../../..)
PKGDIR=../../library
RLIB=$(RHOME)/library

indices:
	PERL5LIB=$(RHOME)/share/perl $(PERL) build.help ${DOS} -htmllists

pkg-% help-%:
	PERL5LIB=$(RHOME)/share/perl $(PERL) build.help ${DOS} -txt -html -example -latex $(PKGDIR)/$* $(RLIB)

chm-%:
	PERL5LIB=$(RHOME)/share/perl $(PERL) build.help ${DOS} -chm $(PKGDIR)/$* $(RLIB)
# hhc always gives an error code
	$(MAKE)  --no-print-directory -C $(PKGDIR)/$*/chm -f $(RHOME)/src/gnuwin32/help/Makefile $*.chm
	$(MKDIR) -p $(RLIB)/$*/chtml
	$(CP) $(PKGDIR)/$*/chm/$*.chm $(RLIB)/$*/chtml

winhlp-%: chm-%
	$(MAKE) --no-print-directory -C $(PKGDIR)/$*/chm -f $(RHOME)/src/gnuwin32/help/Makefile $*.hlp
	$(MKDIR) -p $(RLIB)/$*/winhlp
	$(CP) $(PKGDIR)/$*/chm/$*.cnt $(PKGDIR)/$*/chm/$*.hlp $(RLIB)/$*/winhlp

# need not have HTML installed when building packages
contents-%:
	$(PERL) Rd2contents $(PKGDIR)/$* $(RLIB)/$*/CONTENTS
	@$(MKDIR) -p $(RHOME)/doc/html/search
	$(CAT) $(RHOME)/library/*/CONTENTS > $(RHOME)/doc/html/search/index.txt
	PERL5LIB=$(RHOME)/share/perl $(PERL) build.help ${DOS} -htmllists

ziphelp-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* -f $(RHOME)/src/gnuwin32/help/Makefile ZIPFLAGS=jqX  PKG=$* zipit

ziponlyhelp-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* -f $(RHOME)/src/gnuwin32/help/Makefile ZIPFLAGS=jqmX PKG=$* zipit


winhelp-%:
	$(MAKE) --no-print-directory -C $(PKGDIR)/$* -f $(RHOME)/src/gnuwin32/help/Makefile PKG=$* win

latex-%:
	@$(MAKE) --no-print-directory -C $(RLIB)/$* -f $(RHOME)/src/gnuwin32/help/Makefile PKG=$* unzipit
	PERL5LIB=$(RHOME)/share/perl $(PERL) build.help ${DOS} -latex $(PKGDIR)/$*

clean:
	$(RM) -fr *~ *.o *.obj *.dll *.def *.a

# to be run from src/library/pkg/chm

HTM = $(filter-out 00Index.html, $(wildcard *.html))
%.chm: $(HTM) Rchm.css logo.jpg
	-hhc $*.hhp

%.hlp: %.rtf logo.bmp
	hcrtf /x $*.hpj

%.rtf: $(HTM)
	perl $(RHOME)/share/perl/hhw-to-rtf.pl $*.hhp

Rchm.css: $(RHOME)/src/gnuwin32/help/Rchm.css
	$(CP) $^ $@

logo.jpg: $(RHOME)/doc/html/logo.jpg
	$(CP) $^ $@

logo.bmp: $(RHOME)/src/gnuwin32/help/logo.bmp
	$(CP) $^ $@

# following are designed to be run from the library/pkg directory:

zipit: help/Rhelp.zip zipup
unzipit:
	-@$(MAKE) --no-print-directory -C latex -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp

help/Rhelp.zip: $(wildcard ../../src/library/$(PKG)/man/*.Rd \
../../src/library/$(PKG)/man/windows/*.Rd)
	-@$(MAKE) --no-print-directory -C help  -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp
	-@$(MAKE) --no-print-directory -C R-ex  -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rex
	-@$(MAKE) --no-print-directory -C latex -f $(RHOME)/src/gnuwin32/help/Makefile uz-Rhelp
	-$(MAKE) --no-print-directory -C $(RHOME)/src/gnuwin32/help help-$(PKG)
	@$(RM) -f help/Rhelp.zip latex/Rhelp.zip R-ex/Rex.zip

zipup:
	-zip -${ZIPFLAGS} help/Rhelp help/* -x help/AnIndex 2> nul
	-zip -${ZIPFLAGS} R-ex/Rex R-ex/*.R 2> nul
	-zip -${ZIPFLAGS} latex/Rhelp latex/*.tex 2> nul

uz-%:
	@if test -f $*.zip ; then \
	  unzip -qou $*; \
	fi

=== src/gnuwin32/installer/Makefile ===
# Makefile for R for Windows Installers

include ../MkRules
UNZIPDIR=unzip
PREFIX=rw1030

.PHONY: GA UZ

all: SetupR.exe miniR.exe
old: R.ico GA UZ rwinst.exe

# O1 for small rather than fast
CFLAGS=-I../graphapp -I../../include -I$(UNZIPDIR)/windll -Wall -O1 -DRVER=\"$(PREFIX)\"

GA:
	$(MAKE) -C ../graphapp

UZ:
	$(MAKE) -C $(UNZIPDIR) -f ../Makefile.unzip

R.ico: ../front-ends/R.ico
	$(CP) -p ../front-ends/R.ico .

rwico.o: rwico.rc

rwinst.o: ../../include/Rversion.h ../graphapp/ga.h ../graphapp/graphapp.h

rwinst.exe: rwinst.o rwico.o dounzip.o ../ga.a $(UNZIPDIR)/unzip32.a
	$(CC) -s -mwindows -o $@ $^ -lcomctl32

clean:
	$(RM) R.ico *.o *~ \#*\# rwinst.exe
	-$(MAKE) -C $(UNZIPDIR) -f ../Makefile.unzip clean

#======================================================================

# section for JR software installer.

RECOMMENDED=KernSmooth VR boot cluster foreign mgcv nlme rpart survival
IS: SetupR.exe
# location where Inno Setup was installed
ISDIR=C:/packages/Inno
# location where binary packages are kept
PKGS=C:/R/Rdist/libs1030

R.iss: JRins.pl ../$(PREFIX)b1.zip ../$(PREFIX)b2.zip ../$(PREFIX)h.zip \
../$(PREFIX)ch.zip ../$(PREFIX)d1.zip ../$(PREFIX)d2.zip \
../$(PREFIX)l.zip ../$(PREFIX)sp.zip ../$(PREFIX)w.zip
	unzip -qo ../$(PREFIX)b1
	unzip -qo ../$(PREFIX)b2
	unzip -qo ../$(PREFIX)h
	unzip -qo ../$(PREFIX)ch -d $(PREFIX)ch
	unzip -qo ../$(PREFIX)d1 -d $(PREFIX)d1
	unzip -qo ../$(PREFIX)d2 -d $(PREFIX)d2
	unzip -qo ../$(PREFIX)l -d $(PREFIX)l
	unzip -qo ../$(PREFIX)sp -d $(PREFIX)sp
	unzip -qo ../$(PREFIX)w -d $(PREFIX)w
	for p in $(RECOMMENDED); do \
	  unzip -qo $(PKGS)/$${p} -d $(PREFIX)/library; \
	done
	zip -rmq foo.zip $(PREFIX)/library/*/html
	unzip -qo foo -d $(PREFIX)w
	rm foo.zip
	zip -rmq foo.zip $(PREFIX)/library/*/chtml
	unzip -qo foo -d $(PREFIX)ch
	rm foo.zip
	zip -rmq foo.zip $(PREFIX)/library/*/latex
	unzip -qo foo -d $(PREFIX)l
	rm foo.zip
	perl JRins.pl $(PREFIX)

SetupR.exe: R.iss
	"$(ISDIR)/iscc" R.iss > setupR.log

Rsmall.iss: JRsmall.pl ../$(PREFIX)b1.zip ../$(PREFIX)b2.zip \
  ../$(PREFIX)h.zip ../$(PREFIX)ch.zip ../$(PREFIX)d1.zip
	rm -rf $(PREFIX)*
	unzip -qo ../$(PREFIX)b1
	unzip -qo ../$(PREFIX)b2
	unzip -qo ../$(PREFIX)h
	unzip -qo ../$(PREFIX)ch -d $(PREFIX)ch
	unzip -qo ../$(PREFIX)d1 -d $(PREFIX)d1
	rm $(PREFIX)d1/$(PREFIX)/doc/manual/R-admin.pdf
	rm $(PREFIX)d1/$(PREFIX)/doc/manual/R-exts.pdf
	rm $(PREFIX)d1/$(PREFIX)/doc/manual/R-lang.pdf
	for p in $(RECOMMENDED); do \
	  unzip -qo $(PKGS)/$${p} -d $(PREFIX)/library; \
	done
	rm -rf $(PREFIX)/library/*/html $(PREFIX)/library/*/latex
	rm -rf $(PREFIX)/library/rpart/Manuscript
	rm -rf $(PREFIX)/library/survival/doc
	perl JRsmall.pl $(PREFIX)

miniR.exe: Rsmall.iss
	"$(ISDIR)/iscc" Rsmall.iss > miniR.log

ISclean:
	rm -rf R.iss Rsmall.iss *.log $(PREFIX)*

ISdistclean: ISclean
	rm -f SetupR.exe miniR*

=== debian/changelog ===
r-base (1.3.0-0) unstable; urgency=low

  * Preliminary builds for the next release

 -- Douglas Bates <bates@stat.wisc.edu>  Sun, 20 May 2001 21:06:59 -0500

r-base (1.2.3-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Sun, 20 May 2001 20:51:58 -0500

r-base (1.2.2-2) unstable; urgency=low

  * Corrected format of Closes line (see 1.2.2-1). (Closes: #83876)
  * Added more build-depends entries.  (Closes: #89267)

 -- Douglas Bates <bates@stat.wisc.edu>  Sun, 11 Mar 2001 10:26:36 -0600

r-base (1.2.2-1) unstable; urgency=low

  * New upstream release.
  * Added build-depends entries. (Closes #83876)

 -- Douglas Bates <bates@stat.wisc.edu>  Tue, 27 Feb 2001 12:50:13 -0600

r-base (1.2.1-1) unstable; urgency=low

  * New upstream release.

 -- Douglas Bates <bates@stat.wisc.edu>  Mon, 15 Jan 2001 07:01:21 -0600

r-base (1.2.0-1) unstable; urgency=low

  * New upstream release.
  * Added the r-base-dev package to create the correct dependencies for
    installing R packages from CRAN (Comprehensive R Archive Network)

 -- Douglas Bates <bates@stat.wisc.edu>  Fri, 15 Dec 2000 07:20:51 -0600
    

r-base (1.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Douglas Bates <bates@stat.wisc.edu>  Sat, 17 Jun 2000 13:11:26 -0500

r-base (1.0.1-1) unstable; urgency=low

  * New upstream release.
  * Includes fix for problem with xaxt and yaxt (Closes #61984)

 -- Douglas Bates <bates@stat.wisc.edu>  Sun, 16 Apr 2000 13:50:06 -0500

r-base (1.0.0-2) unstable; urgency=low

  * The pdf documentation is now in a new package r-doc-pdf
  * A GNOME-enabled version is available in a new package r-gnome (Closes #44503)
  * debian/{rules,control}: Modified accordingly
  * Thanks to Dirk Eddelbuettel who did most of the work for this.

 -- Douglas Bates <bates@stat.wisc.edu>  Thu, 16 Mar 2000 16:28:07 -0600

r-base (1.0.0-1) unstable; urgency=low

  * New upstream version
  * Fixed names of info files, readline support (Closes: #57774)
  * Added pdf files to doc directory (Closes: #20227)

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  9 Mar 2000 16:28:29 -0600

r-base (0.99.0-2) unstable; urgency=low

  * Small but important bug fixes in upstream sources
  * Removed dependence on atlas2 - using blas1 instead
  * Recompiled to use the readline library

 -- Douglas Bates <bates@stat.wisc.edu>  Sun, 13 Feb 2000 14:23:25 -0600

r-base (0.99.0-1) unstable; urgency=low

  * New upstream release
  * Added creation and installation of info documentation
  * Created the PDF documentation and added it to the doc directory
  * Added dependence on the atlas2 package and used the atlas blas
  * Added /usr/bin/X11 to the path before configuring so imake is found

 -- Douglas Bates <bates@stat.wisc.edu>  Mon,  7 Feb 2000 10:36:44 -0600

r-base (0.90.1-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Tue, 14 Dec 1999 10:51:10 -0600

r-base (0.90.0-2) unstable; urgency=low

  * added Conflicts: r-cran in control (Closes: #51673)
  * Reinstated -Xfoo flags in call to dh_md5sums for Bug#35744
  * Set up --mandir so package builds with -rfakeroot (Closes: #51901)
  * Undid Dirk's marking of Rd2txt.1 Rdindex.1 Sd2Rd.1 as undocumented
    (the manual pages are symbolic links to the Rdconv.1 page)
  
 -- Douglas Bates <bates@stat.wisc.edu>  Sun,  5 Dec 1999 15:03:52 -0600

r-base (0.90.0-1) unstable; urgency=low

  * Non-maintainer upload dealing with the usr/doc to usr/share/doc
    transition, as well as a  few other lintian errors and warnings 
  * debian/postinst: added #DEBHELPER# stub
  * debian/rules: configure with mandir=/usr/share/man
  * debian/rules: remove extra licenses 
  * debian/rules: also install docs BUGS PLATFORMS VERSION Y2K
  * debian/rules: mark Rd2txt.1 Rdindex.1 Sd2Rd.1 as undocumented
  * debian/dirs: change usr/doc to usr/share/doc
  
 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 25 Nov 1999 20:46:56 -0500

r-base (0.90.0-0) unstable; urgency=low

  * new upstream release
  * Added a "suggests" entry in control for the ess package

 -- Douglas Bates <bates@stat.wisc.edu>  Thu, 25 Nov 1999 13:08:19 -0600

r-base (0.65.1-2) unstable; urgency=low

  * Changed from use of zip/unzip to minizip/miniunzip (Bug#48742)

 -- Douglas Bates <bates@stat.wisc.edu>  Sat, 30 Oct 1999 15:04:42 -0500

r-base (0.65.1-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Fri, 8 Oct 1999 10:04:55 -0500

r-base (0.65.0-1) unstable; urgency=low

  * New upstream release
  * Added dependency on unzip package

 -- Douglas Bates <bates@stat.wisc.edu>  Fri, 27 Aug 1999 09:30:14 -0500

r-base (0.64.2-1) unstable; urgency=low

  * New upstream release
  * Changed dependency from perl to perl5 as per new policy.	
	
 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  1 Jul 1999 09:05:03 -0500

r-base (0.64.1-1) unstable; urgency=low

  * New upstream release
  * Change definition of RHOME in /usr/lib/R/bin/R shell script (Bug#37339)
  * Add links so /usr/lib/R/doc/manual .tex files can be LaTeX'd (Hubert Palme)
  * Re-introduced md5sum's but with files that can change removed (Bug#35744)
  * Removed arbitrary --vsize and --nsize flags in R script.

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 12 May 1999 11:48:22 -0500
    

r-base (0.64.0-2) unstable; urgency=low

  * removed md5sums from control information (Bug#35744)

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  8 Apr 1999 08:48:32 -0500

r-base (0.64.0-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  1 Apr 1999 11:03:17 -0600

r-base (0.63.3-2) unstable; urgency=low

  * Recompile for glibc2.1 to fix __setfpucw bug (Bug#34598)

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 17 Mar 1999 13:42:41 -0600

r-base (0.63.3-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  4 Mar 1999 09:20:41 -0600

r-base (0.63.2-1) unstable; urgency=low



=== debian/control ===
Source: r-base
Section: math
Priority: optional
Maintainer: Douglas Bates <bates@stat.wisc.edu>
Standards-Version: 2.4.0.0
Build-depends: atlas2-dev, libgnome-dev, tcl8.0-dev, tk8.0-dev, libglade-gnome0-dev,bison, g77, groff, libncurses5-dev, libreadline4-dev, tetex-bin, tetex-extra, debhelper

Package: r-base
Architecture: any
Depends: perl5, zlib-bin, ${shlibs:Depends}
Conflicts: r-cran
Suggests: g77, libpaperg, ess
Description: `GNU S' - A language and environment for statistical computing.
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 Versions 0.90.0 and higher have R functions CRAN.packages, install.packages,
 and update.packages that can be used to select and update R packages from the
 Comprehensive R Archive Network.  The Debian packages r-cran, r-cran-non-free,
 and r-mlbench are no longer needed and have been withdrawn.

Package: r-gnome
Architecture: any
Depends: r-base (= ${Source-Version}), ${shlibs:Depends}
Description: `GNU S' - GNOME-enabled executable
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This package provides the executable linked with the GNOME libraries
 for use as
 .
 R --gui=GNOME

Package: r-doc-pdf
Architecture: all
Suggests: pdf-viewer | xpdf | acroread, r-base
Description: `GNU S' documentation in pdf format
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This packages provides the documentation for R in pdf format.

Package: r-base-dev
Architecture: all
Depends: g77, atlas2-dev, wget|lynx
Description: Allow installation of auxillary R packages
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.
 .
 This packages ensures that other Debian packages needed for installation of
 some auxillary R packages are installed.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2000 by Douglas M. Bates <bates@stat.wisc.edu>

package		= r-base
pdfpackage	= r-doc-pdf
gnomepackage	= r-gnome

debbase		:= $(shell pwd)/debian
debtmp		:= $(debbase)/tmp
debdoc		:= $(debtmp)/usr/share/doc/$(package)

# edd 10 Feb 98	See section 4.1 of Policy Manual
arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

build: build-stamp
build-stamp:
	dh_testdir
	R_UNZIPCMD=/usr/bin/miniunzip R_ZIPCMD=/usr/bin/minizip\
	LIBS='-L/usr/lib/atlas'\
	CFLAGS='-Wall -O2' FFLAGS='-Wall -O2'\
	PATH=${PATH}:/usr/bin/X11\   # so /usr/bin/X11/imake is found
	SHLIB_LDFLAGS='-shared -lc' ./configure --prefix=/usr		 \
					--with-g77			 \
					--with-tcltk			 \
					--mandir=$(debtmp)/usr/share/man \
					--with-gnome			 \
                                        --enable-R-profiling             \
					--host $(arch)
	make 
	make help
	make html
	make info 
	make pdf

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	-make distclean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f doc/html/function.html doc/html/packages.html
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	#$(MAKE) prefix=`pwd`/debian/tmp/usr install
	make 
	make check 
	make install		prefix=`pwd`/debian/tmp/usr
	make install-pdf	prefix=`pwd`/debian/tmp/usr
	sed -e '/^R_HOME_DIR=.*/s::R_HOME_DIR=/usr/lib/R:' \
	  < bin/R > debian/tmp/usr/bin/R
	sed -e '/^R_HOME_DIR=.*/s::R_HOME_DIR=/usr/lib/R:' \
	  < bin/R > debian/tmp/usr/lib/R/bin/R
	# remove unneeded license file
	rm -v $(debtmp)/usr/lib/R/COPYING  

	# move the pdf files into the arch-indep. package
	dh_movefiles	-p$(pdfpackage)	usr/lib/R/doc/manual/*.pdf 

	# move the GNOME version to the r-gnome package
	dh_movefiles	-p$(gnomepackage) usr/lib/R/gnome

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: DH_OPTIONS=-i
binary-indep: build install
	# Need this version of debhelper for DH_OPTIONS to work.
	dh_testversion 1.1.17
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
#	dh_installmanpages
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs	NEWS 
	dh_link
	dh_compress
	dh_fixperms
	# You may want to make some executables suid here.
#	dh_suidregister
	dh_installdeb
#	dh_perl
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
# Pass -a to all debhelper commands in this target to reduce clutter.
binary-arch: DH_OPTIONS=-a
binary-arch: build install
	# Need this version of debhelper for DH_OPTIONS to work.
	dh_testversion 1.1.17
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs		BUGS Y2K 
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installmanpages	-N$(gnomepackage) -p$(package) getline.3
	dh_installinfo		-n doc/manual/R-*.info*
	(cd $(debdoc)/doc && ln -s ../../../../lib/R/doc/html .)
	(cd $(debdoc) && ln -s ../../../lib/R/library .)
#	dh_undocumented
	dh_installchangelogs	NEWS 
	dh_strip
	dh_link
	dh_compress
	dh_fixperms
	# You may want to make some executables suid here.
#	dh_suidregister
	dh_installdeb
#	dh_makeshlibs
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums		-X'usr/bin/R'  -XLibIndex -Xindex.txt \
					-Xfunction.html -Xpackages.html
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
